=== debian/changelog ===
musescore-snapshot (3.2.s20190704+dfsg1-1) experimental; urgency=low

  * Merge musescore (3.2.2+dfsg1-1) experimental; urgency=medium
  * Adjust short package description for main package (add “devel”)
  * d/watch: check 3.2.sYYYYMMDD in addition to 3.3~preYYYYMMDD
  * Drop merged patches
  * Merge cosmetic fix from 3.2.2+dfsg1-2 WIP
  * Enable debug menu

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 05 Jul 2019 01:02:34 +0200

musescore (3.2.2+dfsg1-2) UNRELEASED; urgency=low

  * Fix About when build number is empty, cosmetic

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 05 Jul 2019 00:59:36 +0200

musescore (3.2.2+dfsg1-1) experimental; urgency=medium

  * New upstream release
  * Merge musescore-snapshot (3.1+dfsg1-1) experimental; urgency=medium
  * Drop merged patches, update patches
  * Merge musescore2 (2.3.2+dfsg3-4) wtf; urgency=low

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 04 Jul 2019 23:55:01 +0200

musescore-snapshot (3.1+dfsg1-1) experimental; urgency=medium

  * New upstream release, repackaged as snapshot for integration work
  * Apply four post-release bugfixes: three from master, one from the
    musescore.com backend branch that’s not… yet(?) there
  * Update description with new features from 3.0 and 3.1
  * Merge musescore2 (2.3.2+dfsg3-2) wtf; urgency=medium
  * Supplement the AppStream metadata with the new release
  * Fix charset used by local plugin docs
  * Register plugin documentation with doc-base
  * Note known bug https://musescore.org/en/node/290147

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 03 Jun 2019 23:42:38 +0200

musescore-snapshot (3.1~pre20190412+dfsg1-1) experimental; urgency=low

  * New upstream snapshot “v3.1beta”
  * Merge musescore (3.0.5+dfsg1-2) experimental; urgency=low
  * Generate and install full plugin documentation locally
  * Merge musescore (3.0.5+dfsg1-3) experimental; urgency=low

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 19 Apr 2019 22:24:42 +0200

musescore-snapshot (3.1~pre20190227+dfsg1-1) experimental; urgency=low

  * Revert to tracking “git master” snapshots now 3.0.x was branched
  * New upstream snapshot; drop applied and refresh remaining patches

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 27 Feb 2019 21:01:07 +0100

musescore (3.0.5+dfsg1-3) experimental; urgency=low

  * Merge musescore (2.3.2+dfsg2-6) unstable; urgency=medium
  * Mark more patches as applied upstream
  * Adopt package description marker distinguishing from castling branch
  * Update AppData PR patch
  * Add a few crash fix patches until 3.1 is out
  * Clarify the Qt 5.7 patch use in stretch-backports-sloppy *only*
  * Apply recommended settings of debhelper 12

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 04 May 2019 01:55:53 +0200

musescore (3.0.5+dfsg1-2) experimental; urgency=low

  * Merge musescore (2.3.2+dfsg2-5) unstable; urgency=medium
  * Update patches and pull three new bugfix patches from upstream
  * Stop suggesting old tiny soundfonts: we pull in a suitable, large
    one (with better UX) already, and the user can install any SF2/SF3
    or SFZ one by themselves
  * Use the same soundfont as upstream does, for fresh installations
  * Workaround for DEP 5 syntax in a complex case
  * Fix share/plugins/notenames.qml copyright years

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 17 Apr 2019 23:33:14 +0200

musescore (3.0.5+dfsg1-1) experimental; urgency=medium

  * New upstream version, targetting experimental until AFTER buster release

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 13 Mar 2019 17:52:48 +0100

musescore (3.0.4+dfsg1-1) experimental; urgency=low

  * New upstream version, targetting experimental until AFTER buster release
  * Remove applied patches
  * Fix upstream release notes link
  * Apply a reproducibility fix merged in upstream 3.1
  * Automate skipping the testsuite for too-old Qt5, easing backports/PPA

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 07 Mar 2019 22:48:58 +0100

musescore (3.0.3+dfsg1-1) experimental; urgency=low

  * Merge from the musescore-snapshot package but rename it back
  * Rename binary packages to musescore3{,-common} for coïnstallability
    (musescore{,-common} 2.x will stay around for buster’s lifetime, and
    upstream says users should have both in parallel, for existing scores)
  * New upstream version, targetting experimental until AFTER buster release
  * Apply upstream patch to fix sound to not always be piano + some crashes

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 27 Feb 2019 20:02:56 +0100

musescore-snapshot (3.0.2+dfsg1-3) experimental; urgency=high

  * Backport proposed fixes for saving text colours and flipping lyrics

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 18 Feb 2019 00:34:31 +0100

musescore-snapshot (3.0.2+dfsg1-2) experimental; urgency=medium

  * Mark patches as applied upstream
  * Allow manually debugging xvfb testsuite runner
  * Make up a $HOME directory which the testsuite can use

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 07 Feb 2019 19:07:46 +0100

musescore-snapshot (3.0.2+dfsg1-1) experimental; urgency=medium

  * Fix failing tst_runscripts
  * Allow MuseJazz fonts back in, the source code situation was cleared
  * Backport another FTBFS fix
  * New upstream release
    - update copyright
    - refresh all patches and PRs
  * Fix non-constant format string (-Wformat-security)
  * Slight env cleanup for the tests (tbf within pbuilder)

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 06 Feb 2019 21:07:52 +0100

musescore-snapshot (3.0.1+dfsg1-2) experimental; urgency=low

  * Fix XDG_DATA_HOME subpath location in the manpage
  * Merge changes from musescore (2.3.2+dfsg2-3)
  * Update upstream submission status of, and the patches themselves

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 27 Jan 2019 17:06:00 +0100

musescore2 (2.3.2+dfsg3-4) wtf; urgency=low

  * Update UMEGAYA (DEP 12) Changelog link
  * Merge musescore (2.3.2+dfsg2-8) unstable; urgency=low

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 04 Jul 2019 19:37:27 +0200

musescore2 (2.3.2+dfsg3-3) wtf; urgency=high


